% % Econ 202B, by Matthias Doepke, homework 2, problem 2
% % written by Anton Cheremukhin on February 10 2008
close all;
clear all;
clc;

beta=0.94;
a=5;
gama=2.99;
S=10;    %10;
NB=10;   %25;
NW=10;   %25;
eps=0.01;
Y=6:((15-6)/(S-1)):15;
U = @(x) (x>a)*((x-a).^(1-gama))/(1-gama) + (x<=a)*(-100000000);
wmin=U(min(Y))/(1-beta);
wmax=wmin/50;
%bmin=(a+1-max(Y)+0.33);
bmin=(a-max(Y)+1.33);
bmax=max(Y)-min(Y);
%W=wmin:((wmax-wmin)/(NW-1)):wmax;
W=-exp(log(-wmin):((log(-wmax)-log(-wmin))/(NW-1)):log(-wmax));
B=bmin:((bmax-bmin)/(NB-1)):bmax;
PI=ones(size(Y))/size(Y,2);

P1=zeros(size(W));
P=ones(size(W));

F=zeros(1,NB*NW*S);
Aeq=zeros(S+1,NB*NW*S);
beq=zeros(S+1,1);

A=zeros(S*S,NB*NW*S);
b=zeros(S*S,1);

lb=zeros(1,NB*NW*S)';
ub=ones(1,NB*NW*S)';
MULT=zeros(NW,NB*NW*S);

for i=1:NB
    for j=1:NW
        for k=1:S
            n=(k-1)*NW*NB+(j-1)*NB+i;
            %function we are minimizing
%            F(n)=(B(i)-beta*P(j))*PI(k);
            %resource constraint
            if Y(k)+B(i)-a>0
                Aeq(1,n)=( U( Y(k)+B(i) ) + beta*W(j) )*PI(k);
            end
            %probabilities sum up to one
            Aeq(k+1,n)=1;
            beq(k+1,1)=1;
            %truth-telling constraints for y=Y(k) ytilda=Y(k1)
            for k1=1:S
                %the index corresponding to k1,i,j
                n1=(k1-1)*NW*NB+(j-1)*NB+i;
                %the index of the constraint
                ncnstr=(k-1)*S+k1;
                if Y(k)+B(i)-a>0
                    A(ncnstr,n1)=A(ncnstr,n1)+( U( Y(k)+B(i) ) + beta*W(j));
                    A(ncnstr,n)=A(ncnstr,n)-( U( Y(k)+B(i) ) + beta*W(j));
                else
                     A(ncnstr,n1)=A(ncnstr,n1)+(0+beta*W(j));
                     A(ncnstr,n)=A(ncnstr,n)-(0+beta*W(j));                    
                     ub(n)=0;
                end
                b(ncnstr,1)=0;
            end
            for m=1:NW
                if m==j
                    % this matrix will be used to aggregate the
                    % probabilities to find transitional probabilities
                    MULT(m,n)=PI(k);
                end
            end
        end
    end
end

x1=zeros(NW,NB*NW*S);
x2=zeros(NW,NW);

while max(abs(P-P1))>eps

    display(abs(P-P1));
    P=P1;
    for w1=NW:-1:1
        v=W(w1);    %iterate over the promised value
        for i=1:NB
            for j=1:NW
                for k=1:S
                    n=(k-1)*NW*NB+(j-1)*NB+i;
                    %function we are minimizing
                    F(n)=-(-B(i)+beta*P(j))*PI(k);
                    %resource constraint
                    beq(1,1)=v;
                end
            end
        end
       [x,fval,exitflag,output,lambda]  = linprog(F,A,b,Aeq,beq,lb,ub);%,x0);%,options);
        P1(w1)=-F*x;
%        display(reshape(x,NW*NB,S)')
%        display(lambda.ineqlin');
        x1(w1,:)=x'.*kron(ones(1,NB*NW),PI);
        x2(w1,:)=MULT*x;
    end   %end loop over w
end    %end while
figure;
plot(W(NW/2:NW),P1(NW/2:NW),...
    'LineWidth',3);
xlabel('v');
ylabel('P(v)');
title('Profits of the money lender');
%print -depsc2 output5.eps
proby=zeros(NW,NB*S);   %probabilities of consumptions
consump=zeros(1,NB*S);  %consumption values
for i=1:NB
    for j=1:NW
        for k=1:S
            n=(k-1)*NW*NB+(j-1)*NB+i;
            n1=(k-1)*NW+i;
            consump(1,n1)=Y(k)+B(i);    %compute the consumption value
            for m=1:NW
                proby(m,n1)=proby(m,n1)+x1(m,n);    %compute the probability of consumption conditional on wt
            end
        end
    end
end
x0=zeros(1,NW);   %starting distribution where everybody is poor
[va,so]=min(abs(W+0.1));
x0(so)=1;
P2=x0*x2^0*proby;   %dictribution of w2
P5=x0*x2^10*proby;  %dictribution of w10
P10=x0*x2^200*proby;    %dictribution of w200
P100=x0*x2^2000*proby;  %dictribution of w2000
ci=4:0.05:18;        %smaller consumption grid
F2=zeros(1,size(ci,2));
F5=zeros(1,size(ci,2));
F10=zeros(1,size(ci,2));
F100=zeros(1,size(ci,2));
for i=1:size(ci,2)
    for j=1:NB*S;
        if consump(j)<ci(i)      %aggregate to get CDF over a smaller consumption grid
            F2(i)=F2(i)+P2(j);
            F5(i)=F5(i)+P5(j);
            F10(i)=F10(i)+P10(j);
            F100(i)=F100(i)+P100(j);
        end
    end
end
figure;
plot(ci,F2,ci,F5,ci,F10,ci,F100,...
    'LineWidth',3);
legend('t=2','t=10','t=200','t=2000',2)
xlabel('Consumption');
axis([4,17,0,1]);
title('Evolution of consumption CDF over time');
%print -depsc2 output6.eps
